Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExecExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExecExpressionTests.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/ExecExpressionTests.cs	(revision 14602)
@@ -25,5 +25,5 @@
 
     protected override void Test(Expression expression) {
-      this.interpreter.InterpretAsync(expression, true).Wait();
+      this.interpreter.RunAsync(expression, true).Wait();
     }
 
@@ -34,5 +34,5 @@
     public void TestIfTrue() {
       this.interpreter.BooleanStack.Push(true);
-      this.interpreter.Interpret("( EXEC.IF WAHR FALSCH )");
+      this.interpreter.Run("( EXEC.IF WAHR FALSCH )");
 
       Assert.AreEqual("WAHR", this.interpreter.NameStack.Top);
@@ -46,5 +46,5 @@
     public void TestIfFalse() {
       this.interpreter.BooleanStack.Push(false);
-      this.interpreter.Interpret("( EXEC.IF WAHR FALSCH )");
+      this.interpreter.Run("( EXEC.IF WAHR FALSCH )");
 
       Assert.AreEqual("FALSCH", this.interpreter.NameStack.Top);
@@ -109,5 +109,5 @@
     [TestCategory("ExecExpressionTest")]
     public void TestNestedDoRange() {
-      this.interpreter.Interpret(
+      this.interpreter.Run(
         "( 0 2 EXEC.DO*RANGE ( 1 INTEGER.+ 0 3 EXEC.DO*RANGE ( 1 INTEGER.+ INTEGER.* ) INTEGER.+ )");
 
@@ -121,5 +121,5 @@
     [TestCategory("ExecExpressionTest")]
     public void TestNestedDoCount() {
-      this.interpreter.Interpret(
+      this.interpreter.Run(
         "( 2 EXEC.DO*COUNT ( 1 INTEGER.+ 3 EXEC.DO*COUNT ( 1 INTEGER.+ INTEGER.* ) INTEGER.+ )");
 
@@ -133,5 +133,5 @@
     [TestCategory("ExecExpressionTest")]
     public void TestNestedDoTimes() {
-      this.interpreter.Interpret("( 3 EXEC.DO*TIMES ( 2 3 EXEC.DO*TIMES ( 2 INTEGER.* ) INTEGER.+ )");
+      this.interpreter.Run("( 3 EXEC.DO*TIMES ( 2 3 EXEC.DO*TIMES ( 2 INTEGER.* ) INTEGER.+ )");
 
       Assert.AreEqual(128, this.interpreter.IntegerStack.Top);
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/FloatExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/FloatExpressionTests.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/FloatExpressionTests.cs	(revision 14602)
@@ -36,5 +36,5 @@
     {
       this.interpreter.FloatStack.Push(5.3, 5.3);
-      this.interpreter.Interpret(new FloatAddExpression());
+      this.interpreter.Run(new FloatAddExpression());
 
       Assert.AreEqual(10.6, this.interpreter.FloatStack.Top, delta);
@@ -59,5 +59,5 @@
     {
       this.interpreter.FloatStack.Push(10.2, 5.3);
-      this.interpreter.Interpret(new FloatSubtractExpression());
+      this.interpreter.Run(new FloatSubtractExpression());
 
       Assert.AreEqual(4.9, this.interpreter.FloatStack.Top, delta);
@@ -82,5 +82,5 @@
     {
       this.interpreter.FloatStack.Push(9.9, 3.3);
-      this.interpreter.Interpret(new FloatMultiplyExpression());
+      this.interpreter.Run(new FloatMultiplyExpression());
 
       Assert.AreEqual(32.67, this.interpreter.FloatStack.Top, delta);
@@ -105,5 +105,5 @@
     {
       this.interpreter.FloatStack.Push(9.9, 3.3);
-      this.interpreter.Interpret(new FloatDivideExpression());
+      this.interpreter.Run(new FloatDivideExpression());
 
       Assert.AreEqual(3.0, this.interpreter.FloatStack.Top, delta);
@@ -128,5 +128,5 @@
     {
       this.interpreter.FloatStack.Push(11.6, 5.3);
-      this.interpreter.Interpret(new FloatModuloExpression());
+      this.interpreter.Run(new FloatModuloExpression());
 
       Assert.AreEqual(1, this.interpreter.FloatStack.Top, delta);
@@ -151,5 +151,5 @@
     {
       this.interpreter.FloatStack.Push(10.2, 5.3);
-      this.interpreter.Interpret(new FloatMinExpression());
+      this.interpreter.Run(new FloatMinExpression());
 
       Assert.AreEqual(5.3, this.interpreter.FloatStack.Top, delta);
@@ -174,5 +174,5 @@
     {
       this.interpreter.FloatStack.Push(10.3, 5.3);
-      this.interpreter.Interpret(new FloatMaxExpression());
+      this.interpreter.Run(new FloatMaxExpression());
 
       Assert.AreEqual(10.3, this.interpreter.FloatStack.Top, delta);
@@ -197,5 +197,5 @@
     {
       this.interpreter.FloatStack.Push(10.2, 5.3);
-      this.interpreter.Interpret(new FloatSmallerThanExpression());
+      this.interpreter.Run(new FloatSmallerThanExpression());
 
       Assert.AreEqual(false, this.interpreter.BooleanStack.Top);
@@ -220,5 +220,5 @@
     {
       this.interpreter.FloatStack.Push(10.2, 5.3);
-      this.interpreter.Interpret(new FloatGreaterThanExpression());
+      this.interpreter.Run(new FloatGreaterThanExpression());
 
       Assert.AreEqual(true, this.interpreter.BooleanStack.Top);
@@ -243,5 +243,5 @@
     {
       this.interpreter.BooleanStack.Push(true);
-      this.interpreter.Interpret(new FloatFromBooleanExpression());
+      this.interpreter.Run(new FloatFromBooleanExpression());
 
       Assert.AreEqual(1d, this.interpreter.FloatStack.Top, delta);
@@ -257,5 +257,5 @@
     {
       this.interpreter.BooleanStack.Push(false);
-      this.interpreter.Interpret(new FloatFromBooleanExpression());
+      this.interpreter.Run(new FloatFromBooleanExpression());
 
       Assert.AreEqual(0d, this.interpreter.FloatStack.Top, delta);
@@ -280,5 +280,5 @@
     {
       this.interpreter.IntegerStack.Push(5);
-      this.interpreter.Interpret(new FloatFromIntegerExpression());
+      this.interpreter.Run(new FloatFromIntegerExpression());
 
       Assert.AreEqual(5d, this.interpreter.FloatStack.Top, delta);
@@ -303,5 +303,5 @@
     {
       this.interpreter.FloatStack.Push(Math.PI / 2);
-      this.interpreter.Interpret(new FloatSineExpression());
+      this.interpreter.Run(new FloatSineExpression());
 
       Assert.AreEqual(1, this.interpreter.FloatStack.Top, delta);
@@ -326,5 +326,5 @@
     {
       this.interpreter.FloatStack.Push(Math.PI);
-      this.interpreter.Interpret(new FloatCosineExpression());
+      this.interpreter.Run(new FloatCosineExpression());
 
       Assert.AreEqual(-1, this.interpreter.FloatStack.Top, delta);
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/IntegerExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/IntegerExpressionTests.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/IntegerExpressionTests.cs	(revision 14602)
@@ -32,5 +32,5 @@
     {
       this.interpreter.IntegerStack.Push(5, 5);
-      this.interpreter.Interpret(new IntegerAddExpression());
+      this.interpreter.Run(new IntegerAddExpression());
 
       Assert.AreEqual(10, this.interpreter.IntegerStack.Top);
@@ -55,5 +55,5 @@
     {
       this.interpreter.IntegerStack.Push(10, 5);
-      this.interpreter.Interpret(new IntegerSubtractExpression());
+      this.interpreter.Run(new IntegerSubtractExpression());
 
       Assert.AreEqual(5, this.interpreter.IntegerStack.Top);
@@ -78,5 +78,5 @@
     {
       this.interpreter.IntegerStack.Push(10, 5);
-      this.interpreter.Interpret(new IntegerMultiplyExpression());
+      this.interpreter.Run(new IntegerMultiplyExpression());
 
       Assert.AreEqual(50, this.interpreter.IntegerStack.Top);
@@ -101,5 +101,5 @@
     {
       this.interpreter.IntegerStack.Push(10, 5);
-      this.interpreter.Interpret(new IntegerDivideExpression());
+      this.interpreter.Run(new IntegerDivideExpression());
 
       Assert.AreEqual(2, this.interpreter.IntegerStack.Top);
@@ -124,5 +124,5 @@
     {
       this.interpreter.IntegerStack.Push(10, 5);
-      this.interpreter.Interpret(new IntegerModuloExpression());
+      this.interpreter.Run(new IntegerModuloExpression());
 
       Assert.AreEqual(0, this.interpreter.IntegerStack.Top);
@@ -147,5 +147,5 @@
     {
       this.interpreter.IntegerStack.Push(10, 5);
-      this.interpreter.Interpret(new IntegerMinExpression());
+      this.interpreter.Run(new IntegerMinExpression());
 
       Assert.AreEqual(5, this.interpreter.IntegerStack.Top);
@@ -170,5 +170,5 @@
     {
       this.interpreter.IntegerStack.Push(10, 5);
-      this.interpreter.Interpret(new IntegerMaxExpression());
+      this.interpreter.Run(new IntegerMaxExpression());
 
       Assert.AreEqual(10, this.interpreter.IntegerStack.Top);
@@ -193,5 +193,5 @@
     {
       this.interpreter.IntegerStack.Push(10, 5);
-      this.interpreter.Interpret(new IntegerSmallerThanExpression());
+      this.interpreter.Run(new IntegerSmallerThanExpression());
 
       Assert.AreEqual(false, this.interpreter.BooleanStack.Top);
@@ -216,5 +216,5 @@
     {
       this.interpreter.IntegerStack.Push(10, 5);
-      this.interpreter.Interpret(new IntegerGreaterThanExpression());
+      this.interpreter.Run(new IntegerGreaterThanExpression());
 
       Assert.AreEqual(true, this.interpreter.BooleanStack.Top);
@@ -239,5 +239,5 @@
     {
       this.interpreter.BooleanStack.Push(true);
-      this.interpreter.Interpret(new IntegerFromBooleanExpression());
+      this.interpreter.Run(new IntegerFromBooleanExpression());
 
       Assert.AreEqual(1, this.interpreter.IntegerStack.Top);
@@ -262,5 +262,5 @@
     {
       this.interpreter.BooleanStack.Push(false);
-      this.interpreter.Interpret(new IntegerFromBooleanExpression());
+      this.interpreter.Run(new IntegerFromBooleanExpression());
 
       Assert.AreEqual(0, this.interpreter.IntegerStack.Top);
@@ -276,5 +276,5 @@
     {
       this.interpreter.FloatStack.Push(1.5);
-      this.interpreter.Interpret(new IntegerFromFloatExpression());
+      this.interpreter.Run(new IntegerFromFloatExpression());
 
       Assert.AreEqual(1, this.interpreter.IntegerStack.Top);
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/NameExpressionTests.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/NameExpressionTests.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/NameExpressionTests.cs	(revision 14602)
@@ -32,5 +32,5 @@
     public void TestRand()
     {
-      this.interpreter.Interpret(new NameRandExpression());
+      this.interpreter.Run(new NameRandExpression());
 
       Assert.IsTrue(this.interpreter.NameStack.Count == 1);
@@ -49,5 +49,5 @@
       this.interpreter.CustomExpressions.Add("c3", new CodeNoopExpression());
 
-      this.interpreter.Interpret(new NameRandBoundNameExpression());
+      this.interpreter.Run(new NameRandBoundNameExpression());
 
       Assert.IsTrue(this.interpreter.CustomExpressions.Keys.Contains(this.interpreter.NameStack.Top));
@@ -71,5 +71,5 @@
     public void TestQuote()
     {
-      this.interpreter.Interpret(new NameQuoteExpression());
+      this.interpreter.Run(new NameQuoteExpression());
 
       Assert.IsTrue(this.interpreter.IsNameQuoteFlagSet);
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/InterpreterTest.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/InterpreterTest.cs	(revision 14602)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/InterpreterTest.cs	(revision 14602)
@@ -0,0 +1,52 @@
+﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
+using Microsoft.VisualStudio.TestTools.UnitTesting;
+
+namespace HeuristicLab.Tests.Interpreter
+{
+    public class InterpreterTest
+    {
+        protected PushGPInterpreter interpreter;
+
+        [TestInitialize]
+        public void BeforeTest()
+        {
+            interpreter = new PushGPInterpreter(new Configuration
+            {
+                TopLevelPushCode = false
+            });
+        }
+
+        protected void TestStackCounts(int? execStack = 0, int? codeStack = 0, int? nameStack = 0, int? booleanStack = 0, int? floatStack = 0, int? integerStack = 0)
+        {
+            if (execStack.HasValue)
+            {
+                Assert.AreEqual(execStack, interpreter.ExecStack.Count);
+            }
+
+            if (codeStack.HasValue)
+            {
+                Assert.AreEqual(codeStack, interpreter.CodeStack.Count);
+            }
+
+            if (nameStack.HasValue)
+            {
+                Assert.AreEqual(nameStack, interpreter.NameStack.Count);
+            }
+
+            if (booleanStack.HasValue)
+            {
+                Assert.AreEqual(booleanStack, interpreter.BooleanStack.Count);
+            }
+
+            if (floatStack.HasValue)
+            {
+                Assert.AreEqual(floatStack, interpreter.FloatStack.Count);
+            }
+
+            if (integerStack.HasValue)
+            {
+                Assert.AreEqual(integerStack, interpreter.IntegerStack.Count);
+            }
+        }
+    }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/PushGp.sln
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/PushGp.sln	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/PushGp.sln	(revision 14602)
@@ -12,5 +12,5 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.BenchmarkSuite", "HeuristicLab.BenchmarkSuite\HeuristicLab.BenchmarkSuite.csproj", "{22B5C087-CFC7-4D40-86C6-32FCF2CA921E}"
 EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.PushGP", "HeuristicLab.Problems.ProgramSynthesis\HeuristicLab.Problems.PushGP.csproj", "{5C93448C-47E3-4C3F-B1D0-EE62A48C3204}"
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.ProgramSynthesis", "HeuristicLab.Problems.ProgramSynthesis\HeuristicLab.Problems.ProgramSynthesis.csproj", "{5C93448C-47E3-4C3F-B1D0-EE62A48C3204}"
 EndProject
 Global
